use std::{fs::File, io::{Read, Write}};
use env_logger::Builder;
use log::{error, info, LevelFilter};

mod objects;
mod xobjects;
mod deserializer;
mod serializer;

/*
[lib]
crate-type = ["staticlib", "cdylib", "lib"]
*/

fn main() {

    // Initialize the logger with 'info' as the default level
    Builder::new()
        .filter(None, LevelFilter::Info)
        .init();

    // /Users/michael/Documents/ipod/iTunes/iTunesDB
    let mut f = File::open("D:\\Documents\\iTunes\\iTunesDB").unwrap(); // D:\\Documents\\iTunes\\iTunesDB
    let mut buf = Vec::new();
    match f.read_to_end(&mut buf) {
        Ok(n) => {
            let data = &buf[..n];
            let xdb = deserializer::parse_bytes(data);
            //info!("XDB: {:?}", xdb);
            let mut op = File::create("outdb").unwrap();
            info!("Write res: {:?}", op.write(&serializer::to_bytes(xdb)));
        },
        Err(e) => {
            error!("Error: {}",e);
        }
    }
}
